package cn.ibizlab.humanresource.core.humanresource.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.humanresource.core.humanresource.domain.HRTechnicalTitle;
import cn.ibizlab.humanresource.core.humanresource.filter.HRTechnicalTitleSearchContext;
import cn.ibizlab.humanresource.core.humanresource.service.IHRTechnicalTitleService;

import cn.ibizlab.humanresource.util.helper.CachedBeanCopier;
import cn.ibizlab.humanresource.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.humanresource.core.humanresource.mapper.HRTechnicalTitleMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[职称信息] 服务对象接口实现
 */
@Slf4j
@Service("HRTechnicalTitleServiceImpl")
public class HRTechnicalTitleServiceImpl extends ServiceImpl<HRTechnicalTitleMapper, HRTechnicalTitle> implements IHRTechnicalTitleService {

    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHREmployeeService hremployeeService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(HRTechnicalTitle et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getHrtechnicaltitleid()),et);
        return true;
    }

    @Override
    public void createBatch(List<HRTechnicalTitle> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(HRTechnicalTitle et) {
        fillParentData(et);
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("hrtechnicaltitleid",et.getHrtechnicaltitleid())))
            return false;
        CachedBeanCopier.copy(get(et.getHrtechnicaltitleid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<HRTechnicalTitle> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public HRTechnicalTitle get(String key) {
        HRTechnicalTitle et = getById(key);
        if(et==null){
            et=new HRTechnicalTitle();
            et.setHrtechnicaltitleid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public HRTechnicalTitle getDraft(HRTechnicalTitle et) {
        fillParentData(et);
        return et;
    }

    @Override
    public boolean checkKey(HRTechnicalTitle et) {
        return (!ObjectUtils.isEmpty(et.getHrtechnicaltitleid()))&&(!Objects.isNull(this.getById(et.getHrtechnicaltitleid())));
    }
    @Override
    @Transactional
    public boolean save(HRTechnicalTitle et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(HRTechnicalTitle et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<HRTechnicalTitle> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<HRTechnicalTitle> list) {
        list.forEach(item->fillParentData(item));
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<HRTechnicalTitle> selectByHremployeeid(String employeeid) {
        return baseMapper.selectByHremployeeid(employeeid);
    }

    @Override
    public void removeByHremployeeid(String employeeid) {
        this.remove(new QueryWrapper<HRTechnicalTitle>().eq("hremployeeid",employeeid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<HRTechnicalTitle> searchDefault(HRTechnicalTitleSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRTechnicalTitle> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRTechnicalTitle>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 高级
     */
    @Override
    public Page<HRTechnicalTitle> searchHigh(HRTechnicalTitleSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRTechnicalTitle> pages=baseMapper.searchHigh(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRTechnicalTitle>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 初级
     */
    @Override
    public Page<HRTechnicalTitle> searchJunior(HRTechnicalTitleSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRTechnicalTitle> pages=baseMapper.searchJunior(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRTechnicalTitle>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 中级
     */
    @Override
    public Page<HRTechnicalTitle> searchMiddle(HRTechnicalTitleSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRTechnicalTitle> pages=baseMapper.searchMiddle(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRTechnicalTitle>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }

    /**
     * 查询集合 正高级
     */
    @Override
    public Page<HRTechnicalTitle> searchSenior(HRTechnicalTitleSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRTechnicalTitle> pages=baseMapper.searchSenior(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRTechnicalTitle>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(HRTechnicalTitle et){
        //实体关系[DER1N_HRTECHNICALTITLE_HREMPLOYEE_HREMPLOYEEID_327A4D]
        if(!ObjectUtils.isEmpty(et.getHremployeeid())){
            cn.ibizlab.humanresource.core.humanresource.domain.HREmployee hremployee=et.getHremployee();
            if(ObjectUtils.isEmpty(hremployee)){
                cn.ibizlab.humanresource.core.humanresource.domain.HREmployee majorEntity=hremployeeService.get(et.getHremployeeid());
                et.setHremployee(majorEntity);
                hremployee=majorEntity;
            }
            et.setHremployeename(hremployee.getEmployeename());
            et.setEmployeecode(hremployee.getEmployeecode());
            et.setOrganizationname(hremployee.getOrganizationname());
            et.setOrganizationid(hremployee.getOrganizationid());
            et.setEmpstate(hremployee.getEmpstate());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<HRTechnicalTitle> getHrtechnicaltitleByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<HRTechnicalTitle> getHrtechnicaltitleByEntities(List<HRTechnicalTitle> entities) {
        List ids =new ArrayList();
        for(HRTechnicalTitle entity : entities){
            Serializable id=entity.getHrtechnicaltitleid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



